Structure ENTRY
  name.s
  file.s
  index.l
EndStructure

Global win.l, lastText.s, NewList list.ENTRY(), listFile.s
listFile = GetPathPart(ProgramFilename()) + "\list.txt"

If ReadFile(0, listFile)
  While Not Eof(0)
    s.s = ReadString(0)
    If FindString(s, "=", 1)
      AddElement(list())
      list()\name = Trim(StringField(s, 1, "="))
      list()\file = Trim(StringField(s, 2, "="))
    EndIf
  Wend
  CloseFile(0)
EndIf


win = OpenWindow(0, -1, -1, 250, 300, "AppLauncher")
StickyWindow(0, 1)
CreateGadgetList(win)
StringGadget(0, 5, 5, WindowWidth(0) - 10, 20, "")
ListViewGadget(1, 5, 30, WindowWidth(0) - 10, WindowHeight(0) - 60)
ButtonGadget(2, 5, WindowHeight(0) - 25, 80, 20, "Neuer Eintrag")

AddKeyboardShortcut(0, #PB_Shortcut_Return, 0)
AddKeyboardShortcut(0, #PB_Shortcut_Escape, 1)


Procedure UpdateList(search.s)
  ClearGadgetItemList(1)
  i = 0
  ForEach list()
    If FindString(LCase(list()\name), LCase(search), 1) Or search = ""
      AddGadgetItem(1, -1, list()\name)
      list()\index = i
      i + 1
    Else
      list()\index = -1
    EndIf
  Next
  
  CreateFile(0, listFile)
  ForEach list()
    WriteStringN(0, list()\name + "=" + list()\file)
  Next
  CloseFile(0)
EndProcedure

UpdateList("")

SetActiveGadget(0)

Repeat
  e = WaitWindowEvent()
  SetActiveWindow(0)
  
  If e = #PB_Event_Menu
    If EventMenu() = 0
      sel = GetGadgetState(1)
      If sel <> -1
        ForEach list()
          If list()\index = sel
            If list()\file <> ""
              RunProgram(list()\file)
            EndIf
            End
          EndIf
        Next
      Else
        ForEach list()
          If FindString(LCase(list()\name), LCase(lastText), 1)
            RunProgram(list()\file)
            End
          EndIf
        Next
        End
      EndIf
    ElseIf EventMenu() = 1
      End
    EndIf
  EndIf
  
  If e = #PB_Event_Gadget
    If EventGadget() = 2
      name.s = InputRequester("Neuer Eintrag", "Name", "")
      file.s = OpenFileRequester("Neuer Eintrag", "", "", 0)
      create.l = #True
      
      ForEach list()
        If LCase(list()\name) = LCase(name)
          If MessageRequester("Warnung", "Ein Eintrag mit demselben Namen existiert bereits. Soll er ersetzt werden?", #MB_ICONQUESTION | #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
            list()\name = name
            list()\file = file
            create = #False
            UpdateList(lastText)
          EndIf
        EndIf
      Next
      
      If create
        AddElement(list())
        list()\name = name
        list()\file = file
        UpdateList(lastText)
      EndIf
    EndIf
  EndIf
  
  If GetGadgetText(0) <> lastText
    lastText = GetGadgetText(0)
    UpdateList(lastText)
  EndIf
Until e = #PB_Event_CloseWindow

; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 54
; FirstLine = 24
; Folding = -
; EnableXP
; Executable = AppLauncher.exe
; DisableDebugger